#include <math.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

#define     pi          3.14159265358979323846264338327950288

#define     MAX_LINE_LENGTH 136
#define     NODES       1000000
#define     ELEMENTS    1000000
#define     MAX_LOADCASES  100000
#define     MAX_NODES_PER_ELEMENT 20
#define     MAX_NAME_LENGTH 8
#define     MAX_SUM_ASCI    4100        /* = (MAX_NAME_LENGTH**2 * 128)/2 = 4096 */

/* intpol2.c, spline.c */
#define     PNTS  2000

/* from #include "f2c.h" */
#define abs(x) ((x) >= 0 ? (x) : -(x))
#define dabs(x) (double)abs(x)
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (double)min(a,b)
#define dmax(a,b) (double)max(a,b)

typedef struct {
  char  model[MAX_LINE_LENGTH]; /* haeder model */
  int   n;   /* nodes     */
  int   e;   /* elements  */
  int   l;   /* loadcases (total) */
  int   lcq[MAX_LOADCASES];   /* speichert das Femview-Flag der Loadcases */
  int   etype[100]; /* anzahl gefundener elemente einer elementtyp-nr. */
  int   nmax;      /* maximale nodenummer */
  int   nmin;      /* minimale nodenummer */
  int   emax;      /* maximale elemnummer */
  int   emin;      /* minimale elemnummer */
} Summen;

typedef struct {
  int   nr;
  char  pflag;  /* 1 if used for display purposes */
  float nx;     /* coordinates will be scaled during run, scalNodes() */
  float ny;
  float nz;
} Nodes;

typedef struct {
  int nr;
  int type;
  int group;
  int mat;
  int nod[MAX_NODES_PER_ELEMENT+1];
} Elements;

typedef struct {
  float *sxx;
  float *syy;
  float *szz;
  float *sxy;
  float *syz;
  float *szx;
  float *dat;
  float **esxx;
  float **esyy;
  float **eszz;
  float **esxy;
  float **esyz;
  float **eszx;
  float **edat;
  char  *compName[20];
  char  name[MAX_LINE_LENGTH];
  float sxx_max;
  float syy_max;
  float szz_max;
  float sxy_max;
  float syz_max;
  float szx_max;
  float dat_max;
  float sxx_min;
  float syy_min;
  float szz_min;
  float sxy_min;
  float syz_min;
  float szx_min;
  float dat_min;
} Loadcases;

int read2frd(char *datin, Summen *anz, Nodes **nptr, Elements **eptr, Loadcases **lptr );
float stof(char *string, int a, int b);
int stoi(char *string, int a, int b);
void stos(char *string, int a, int b, char *puffer);
int write2frd(unsigned char *datout, Summen *anz, Nodes *node, Elements *elem, Loadcases *lcase );
int frecord( FILE *handle1,  unsigned char *string);
int* elemChecker(Summen *anz, Nodes *node, Elements *elem);
int compare (char *str1, char *str2, int length);
void *u_calloc(size_t num,size_t size);
float v_betrag(float *a);
void v_prod( float *A, float *B, float *C );
void v_result( float *A, float *B, float *C );


