!
!     CalculiX - A 3-dimensional finite element program
!              Copyright (C) 1998-2012 Guido Dhondt
!
!     This program is free software; you can redistribute it and/or
!     modify it under the terms of the GNU General Public License as
!     published by the Free Software Foundation(version 2);
!     
!
!     This program is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of 
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
!     GNU General Public License for more details.
!
!     You should have received a copy of the GNU General Public License
!     along with this program; if not, write to the Free Software
!     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
      subroutine interpretinput(text,label,nk,long,no,ne,nkon,
     &  nindex,nfield,ndfield,field,ipkon,kon,kontyp,co,iel)
!
      implicit none
!
      logical long
!
      character*1 c1
      character*132 text
!
      integer nk,no(*),ne,nkon,nindex(*),nfield,ipkon(*),kon(*),iel(*),
     &  kontyp(*),key,ictype,iexist,ndfield,i,j,nonzero,node,id,label,
     &  iformat
!
      real*8 co(3,*),field(nk,nfield)
!
      read(text(6:6),'(a1)') c1
!
      if((c1.eq.'C').and.(text(2:2).ne.'-')) then
         read(text(2:5),'(i4)') label
         if(label.eq.100) then
            ndfield=0
         endif
         read(text(74:75),'(i2)') iformat
         if(iformat.ne.0) then
            long=.true.
         else
            long=.false.
         endif
         return
      endif
!
      read(text(1:3),'(i3)') key
!
      if(key.eq.-1) then
         if(label.eq.2) then
            nk=nk+1
            nindex(nk)=nk
            if(long) then
               read(text(4:13),'(i10)') no(nk)
               read(text(14:49),'(3e12.5)')(co(i,nk),i=1,3)
            else
               read(text(4:8),'(i5)') no(nk)
               read(text(9:44),'(3e12.5)')(co(i,nk),i=1,3)
            endif
         elseif(label.eq.3) then
            ne=ne+1
            ipkon(ne)=nkon
            if(long) then
               read(text(4:13),'(i10)') iel(ne)
               read(text(14:18),'(i5)') kontyp(ne)
            else
               read(text(4:8),'(i5)') iel(ne)
               read(text(9:13),'(i5)') kontyp(ne)
            endif
         elseif(label.eq.100) then
            if(long) then
               read(text(4:13),'(i10)') node
               call nident(no,node,nk,id)
               if(id.gt.0) then
                  if(no(id).eq.node) then
                     read(text(14:85),'(6e12.5)') 
     &                 (field(nindex(id),j),j=nfield+1,nfield+ndfield)
                  endif
               endif
            else
               read(text(4:8),'(i5)') node
               call nident(no,node,nk,id)
               if(id.gt.0) then
                  if(no(id).eq.node) then
                     read(text(9:80),'(6e12.5)') 
     &                 (field(nindex(id),j),j=nfield+1,nfield+ndfield)
                  endif
               endif
            endif
         endif
      elseif(key.eq.-2) then
         if(long) then
            read(text(4:103),'(10i10)') (kon(j),j=nkon+1,nkon+10)
            nonzero=0
            do j=nkon+1,nkon+10
               if(kon(j).ne.0) then
                  call nident(no,kon(j),nk,id)
                  if(id.gt.0) then
                     if(no(id).eq.kon(j)) then
                        kon(j)=nindex(id)
                     else
                        write(*,*) '*ERROR in interpretinput'
                        write(*,*) '       node',kon(j),'in element'
                        write(*,*) iel(ne),'is not defined'
                        stop
                     endif
                  else
                     write(*,*) '*ERROR in interpretinput'
                     write(*,*) '       node',kon(j),'in element'
                     write(*,*) iel(ne),'is not defined'
                     stop
                  endif
                  nonzero=nonzero+1
               else
                  exit
               endif
            enddo
            nkon=nkon+nonzero
         else
            read(text(4:78),'(15i5)') (kon(j),j=nkon+1,nkon+15)
            nonzero=0
            do j=nkon+1,nkon+15
               if(kon(j).ne.0) then
                  call nident(no,kon(j),nk,id)
                  if(id.gt.0) then
                     if(no(id).eq.kon(j)) then
                        kon(j)=nindex(id)
                     else
                        write(*,*) '*ERROR in interpretinput'
                        write(*,*) '       node',kon(j),'in element'
                        write(*,*) iel(ne),'is not defined'
                        stop
                     endif
                  else
                     write(*,*) '*ERROR in interpretinput'
                     write(*,*) '       node',kon(j),'in element'
                     write(*,*) iel(ne),'is not defined'
                     stop
                  endif
                  nonzero=nonzero+1
               else
                  exit
               endif
            enddo
            nkon=nkon+nonzero
         endif
      elseif(key.eq.-3) then
         if(label.eq.100) then
            nfield=nfield+ndfield
         endif
      elseif(key.eq.-5) then
         read(text(19:23),'(i5)') ictype
         read(text(34:38),'(i5)') iexist
         if(iexist.ne.1) then
            ndfield=ndfield+1
         endif
c         ndfield=ndfield+ictype*iexist
c         if(ictype.eq.1) then
c            ndfield=ndfield+1
c         elseif(ictype.eq.2) then
c            ndfield=ndfield+3
c         elseif(ictype.eq.4) then
c            ndfield=ndfield+6
c         elseif(ictype.eq.12) then
c            ndfield=ndfield+6
c         else
c            write(*,*) '*ERROR in interpretinput: ictype unknown'
c            stop
c         endif
      endif
!
      return
      end

